/*   Programik do gry w kropki -- deklaracje podstawowych klas.
 *
 *  Copyright (C) 1999,2001,2002,2003,2004,2005,2006 Bartek Dyda <bkropki@yahoo.co.uk>.
 * 
 *  This file is part of Kropki.
 *
 *  Kropki is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2,
 *  as published by the Free Software Foundation.
 *
 *  Kropki is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License, version 2, for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Kropki; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef EKROXXYY__H
#define EKROXXYY__H

#include <assert.h>
#include "pla_skl.h"
#include "stoper.h"
#include "slownik.h"
#ifndef TEKSTOWY
  #include "X2grx.h"
  extern char nazwa_pliku_pomocy[256];
#endif
extern TStoper stoper[3];
extern TSkladowe skladowe;
extern TPlansze  plansze;
extern TTabliceLI tabliceLI;
extern TSlowa slowa;

#define MAX_GRACZY_W_TURN  20

// stale trybu gry
#define  TRYB_GRA     0
#define  TRYB_TURNIEJ 1
#define  TRYB_CZAS    2
// TRYB_PAUZA moze towarzyszyc dowolnemu z 3 pozostalych trybow (np. TRYB_GRA | TRYB_PAUZA)
#define  TRYB_PAUZA   4

#define WS_KTONARUCHU   0
#define WS_KROPKA       1
#define WS_POWIERZCHNIA 2
#define WS_STOP         3
#define WS_CALAPLANSZA  4
#define WS_NOWAPLANSZA  5
#define WS_NOWYZARODEK  100
#define WS_BLADPLIKU    101
#define WS_ODCZYTMECZU  102

#define ZD_NIC          0
#define ZD_NOWAGRA      1
#define ZD_COFNIJ       2
#define ZD_BLOKADA      3
#define ZD_ZAPIS        5
#define ZD_ODCZYT       6
#define ZD_USTAWZARODEK        7
#define ZD_USTAWZARODEKLOSOWY  8
#define ZD_OPUSCRUCH    9
#define ZD_ZMIENGRACZY  10
#define ZD_KROPKA       11
#define ZD_KONIEC       12
#define ZD_INFORMACJE   13   /* potrzebne 13-14 */
#define ZD_ODCZYT_MECZU 15
#define ZD_TRYB         20

struct TGraczO {
  short int komputer;
  short int poziom_gry;
  short int dokl_analizy;            // glebokosc analizy
  short int funkcja_sk;
  short int Bouzy_dil, Bouzy_er;
  long int czas_sek, czas_ssek, czas_kiedy;
  unsigned long int umiejetnosci;
  long int waga_kropki;             // =wartosc zdobytej kropki/zdobytej powierzchnii
  struct TWagi {
    long int  zd, sk, Bo;
  } wagi_n, wagi_p;
  short int sex_limit, sex_limit_podw;  // limit na singular extensions (82.35+)
  unsigned long int testowe;
  unsigned short int opcje_Bouzy;
  unsigned short int waga_latwe_pole;
  signed char listy_ruchow[4];   // nasze, przec, przedost, lisc
  long int zapasowe[12];
  char imie[30], imie_k[5][30];
  void  UstawImie();
  int   Wstaw(unsigned char *s);
  void  Daj(unsigned char *s);
  TGraczO& operator&=(TGraczO);
  int   Odczytaj(FILE *);
  void  Zapisz(FILE *);
  TGraczO()
    {
      memset(this, 0, sizeof(*this));
    komputer=1;  poziom_gry=12;
    strcpy(imie, "Pik");
    wagi_n.zd = 64*14;
    wagi_n.sk = 10;        // agresja =2
    wagi_p.zd = 64*10;     // przejmuje sie =64
    wagi_p.sk = 14;
    wagi_n.Bo = 30; wagi_p.Bo = 30;
    Bouzy_dil=Bouzy_er=0;
    opcje_Bouzy=1;
    waga_latwe_pole=0;
    dokl_analizy=4;  umiejetnosci=1|4|0x10|0x20|0x40|0x200; //|0x100;  QS nie
    funkcja_sk=5;
    waga_kropki=5;
    czas_kiedy=0;
    czas_sek=10;
    czas_ssek=0;
    //sex_limit=1;  sex_limit_podw=0;
    sex_limit=0;  sex_limit_podw=0;
    testowe=0;
    listy_ruchow[0]=0;  // sensowne wydaja sie tez: (0,2,1,0), ew. (-1,2,1,0)  (choc to ostatnie ryzykowne)
    listy_ruchow[1]=3;
    listy_ruchow[2]=1;
    listy_ruchow[3]=0;
    };
  private:
  void DodajTekstCzas(char *s);
  };

struct TKalendarzRozgr {
  short int rozgr_w_sezonie;
  struct TMecz {
    short int g1,g2;    // gracze, zaczyna g1
  } *mecze;
  int Odczytaj(FILE *f);
  int Zapisz(FILE *f);
  void KazdyZKazdym(int);
  TKalendarzRozgr& operator=(TKalendarzRozgr& arg);
  TKalendarzRozgr() {mecze=NULL;};
  ~TKalendarzRozgr() {if (mecze!=NULL) delete[] mecze;};
  };

struct TMecz {
  int nr_sez, nr_mecz;
  int ile_zd[2];
  TStoper czas[3];
};
  
struct TTurniej {
  int ile_graczy;
  int plx,ply;
  TGraczO *gracze;
  TKalendarzRozgr  kalendarz;
  char nazwa_t[80];  // nazwa pliku .t
  int ktory_sezon;
  int ktory_mecz;         // aktualnie rozgrywany mecz
  int wersja_m;         // wersja pliku .m
    int offset_rozgr, dlug_rozgr;   // offset poczatku rozgrywek w pliku
  FILE *f;  // tylko do funkcji zw. ze statystyka
  // metody
    TTurniej() { gracze = new TGraczO[MAX_GRACZY_W_TURN]; assert(gracze!=NULL); f=NULL; };
  ~TTurniej() { delete[] gracze; if (f!=NULL) fclose(f); }
  void Zapisz();
  void WezGraczyWAktMeczu(TGraczO *gr);
  int Odczytaj();
  int OdczytajMecz(int nrs, int nrm);
  int Nowy();
  void NowyMecz();
  int  KtoryMecz();    // jest teraz
  int  KtorySezon();   // rozgrywany
  // do statystyki:
  int OdczytajNagl();
  void UstawMecz(int, int);
  int OdczytajInfoOMeczu(TMecz&, int tylko_gra_srodkowa);
  int ZapiszInfoOTurnieju(FILE*);
  private:

  };

struct TParametryGry
  {
  int x,y,ile,tryb,blokada,kod;
  TGraczO gr[MAX_GRACZY_W_TURN];
  TKalendarzRozgr kalendarz;
  char nz1[256];
  };

class TGra
  {
    friend class TTurniej;
  unsigned char *rozgr, *stopy, *plansz_p;
  krint *historia;
  int ile_hist;
  int tryb, blokada;
  int ktory_gracz;   // ktory gracz na ruchu, =0 lub =1, lub -1, gdy koniec gry
  int ile_zd[2], pow_ss[2];
  int koncowka;                 // czy juz koncowka
  short int ile_zd_do_konc[2];  // wynik w grze srodkowej
  TGraczO gr[2];
  unsigned long int zarodek_pocz[2];  // poczatkowe wartosci bseed1,2
  TTurniej turniej;
  void WykonajRuch(int x, int y, int tylko_ruch=0);
  void UstawRuch(int x, int y);
  // pomocnicza strukturka:
  struct TZapis {
    short int wx, wy, ik, ile_zd1, ile_zd2;
    unsigned short int slowo;
    short int wersja_hi, wersja_lo;
    long int data_utw;
    unsigned long int zarp1, zarp2, zark1, zark2;
    long int ktory_sezon, ktory_mecz;
    void Zapisz(FILE *f);
    int  Odczytaj(FILE *f);
  };
  // funkcje obslugujace pliki
  void ZapiszRozgr(FILE *f, int ktory_sezon=0, int ktory_mecz=0);
  int OdczytajRozgr(FILE *f, int *numery=NULL);
  static int OdczytajInfoOMeczu(FILE *f, TMecz&, int tylko_gra_srodkowa);
  //
  public:
  void ObsluzZdarzenie(int zd);
  TGra();
  void NowaGra(int x, int y);
  void CzyscPlansze(int zapamietaj_zarodek=0);
  void GlownaPetla();
  void PrzydzielPamiec();
  // do analizy
  int DNajlepszyRuch(int& x, int& y, int wybierz_ruchy=0);
  // funkcje zwracajace wartosci parametrow, ,,D'' od daj
  int DTryb();
  int DBlokada();
  int DKropka(int x, int y);
  int DKreska(int x, int y);
  int DKreska(int x, int y, int x2, int y2);
  int DPlanszP(int x, int y);
  int DIleKropek();
  int DOstKropkaX();  int DOstKropkaY();
  int DNaRuchu();
  int DKomputerNaRuchu();
  int DWlkX();    int DWlkY();
  int DIleZd(int);   int DPowSS(int);
  void DGracza(int nr, TGraczO &ngr);
  int DPola(int*, int, int, int, int, int);
  unsigned int DHTAktCzas();
  void DJakasTablice(krint*, char*, int);
  //  int  TestSzybkosci(int kod, int iteracji, TStoper&);
  krint& DElTabl(krint*, int, int) const;
  unsigned char& DElTabl(unsigned char*, int, int) const;
  int DSStoper(int, char*);
  // funkcje obslugujace pliki
  int DInfoOPliku(const char*, int&, int&, int&, TGraczO *gracze=NULL,
                int *ile_zd=NULL, int *pow_ss=NULL);
  int DInfoOPliku(FILE*, int&, int&, int&, TGraczO *gracze=NULL,
                int *ile_zd=NULL, int *pow_ss=NULL);
  // funkcje obslugujace stopery
  void StoperyOdNowa();
  void StoperyWstrzymaj();
  void StoperyWznow();
  void StoperyStop();
  // funkcje obslugujace turniej
  int DNrSezonu();
  int DNrMeczu();
  int DNrGracza(int);
  // funkcje ustawiajace parametry (do obslugi pliku konfiguracyjnego)
  void UstawImie(int, const char*);
  };

// do pokazywania analizy:
struct TStatystykaDlaAnalizy {
  long long int funk_ocen, wez_ht;
};
extern TStatystykaDlaAnalizy  statystyka_dla_analizy;
struct TJedenRuch { 
  int x,y; 
  int operator==(const TJedenRuch); 
  TJedenRuch(int nx, int ny);
  TJedenRuch();
};
//typedef TJedenRuch TSekwencjaRuchow[8];
struct TSekwencjaRuchow {
  TJedenRuch r[8];
};

// statystyki programu:
struct TStatystyki {
  long long int ht_kolizja[4];
  // [0] = brak kolizji
  // [1] = mala kolizja, oznacza utrate pozycji, ktora moze pomoc tylko w sortowaniu
  // [2] = srednia kolizja, oznacza utrate pozycji, ktora zostala uznana
  //       za mniej wazna niz wstawiana
  // [3] = duza kolizja, oznacza niemoznosc wstawienia pozycji
};
extern TStatystyki   statystyki_prog;
// i deklaracje dla ekranu:

//
class TRysujPlansze;
class TRysujGraczy;
class TElMenu;
class TPlikiMenu;
class TTurniejMenu;
class TWiersze;
class TWierszeInf;
class TOpcjeWysw;

#ifdef TEKSTOWY
typedef int TKolor;
#else
class TPokazAnalize;
#endif

class TEkran
  {
  TRysujPlansze *plansza;
  TRysujGraczy  *gracze;
  TElMenu       *glowne_menu;
  TPlikiMenu    *pliki_menu;
  TTurniejMenu  *turniej_menu;
  TWierszeInf   *informacje;
#ifndef TEKSTOWY
  public:
  TPokazAnalize *analiza;
  private:
#endif
   short int wgm[60];   // ,,gm'' to skrot
   TKolor    kgm[6];    // od glowne_menu
  int rozdz_x, rozdz_y;
  int wys_graczy;
  TKolor  kolor_zolty, kolor_tla, kolor_menu, kolor1, kolor2;
  TKolor  kolor_zielony, kolor_zielony_tla;
  int krotkie_imie;
  int jaki_font;
  int  UstawSzerGlMenu(int szer);
  int  Cofnij();
  int  WezNowaGre(int x, int y);
  private:
  void PokazStopy(int nr_maski);
  void PokazWolnePola();
  void PokazJakasTablice();
  //  void JakisTestSzybkosci();
  void WezOpcje();
  public:
  void ZaladujFont(char*);
  void UstawRozdzielczosc(int x, int y);
  void UstawWersje(int w, int wlow, int,int,int);
  void WyswietlPlansze(int co);
  void WyswietlGraczy();
  void WyswietlTryb();
  void WyswietlBlokade();
  void WyswietlInformacje(int);
  void WyswietlInfoOMeczu();
  void WyswietlCzasGry();
  void WyswietlWszystko();
  void WyswietlInfoOProgramie();
  void WyswietlObwodke(int, int, int);  // wyswietl lub skasuj
    void WyswietlNapis(char *);  // do testow
  int  DajZdarzenie();
  int  CzekajNaZdarzenie(int czekaj=1);
  TEkran();
  ~TEkran();
  TKolor DajKolorTla();
  TKolor DajKolorMenu();
  TKolor DajKolorNieaktMenu();
  TKolor DajKolorZolty();
  TKolor DajKolorGracza(int);
  TKolor DajKolorZielony();
  TKolor DajKolorZielonyTla();
  int DajRozdzX();
  int DajRozdzY();
  int CzyKrotkieImie();
#ifndef TEKSTOWY
  void WezOpcje(TSlowa &opcje);
  void PoczatekAnalizy();
  void MinimaxPoczatek();
  void JeszczeRazAktGleb();
  void OcenionyRuch(int gleb, int maxg, int ocena, TSekwencjaRuchow *r, int ile_r);
  void NowyRuch(int gleb, TJedenRuch r, int ktoryr, int ile_pierw_r, int ile_r);
  void KoniecAnalizy();
  int  CzyPrzerwacAnalize();
  int  WezListeRuchow(unsigned char*);
#endif
  };


extern TGra          gra;
extern TEkran        ekran;
extern TParametryGry pargry;

#endif
